Attribute VB_Name = "mdlDatabase"
Option Explicit

Public Function Get_Field_Data(ByRef conApp As ADODB.Connection, ByVal strField As String, _
    ByVal strTable As String, ByVal strCriteria As String) As String
    Dim rstData As ADODB.Recordset
    
    Set rstData = Open_Recordset(conApp, strField, strTable, False, strCriteria)
    
    If rstData.RecordCount > 0 Then
        rstData.MoveFirst
        
        Get_Field_Data = rstData(0)
    Else
        Get_Field_Data = ""
    End If
    
    Set rstData = Nothing
End Function

Public Function Create_SQL_Database(ByVal strDatabase As String, _
    Optional ByVal strServer As String = "localhost", Optional ByVal strUser As String = "sa")
    Set conFin = New ADODB.Connection
    On Error GoTo ErrHandler
    
    conFin.Open "Provider=SQLOLEDB.1;Persist Security Info=False;User ID=" & strUser & _
        ";Data Source=" & strServer
    
    conFin.Execute "CREATE DATABASE " & strDatabase
    
    Exit Function
    
ErrHandler:
    MsgBox MSG_PROGRAM_ERROR, MSG_BOX_CONTROL_OK_CRIT, MJSTONE

    End
End Function

Public Function Open_Recordset(ByRef conApp As ADODB.Connection, ByVal strSelect As String, _
    ByVal strFrom As String, Optional ByVal blnActive As Boolean = True, _
    Optional ByVal strWhere As String = "", Optional ByVal strOrderBy As String = "") _
    As ADODB.Recordset
    Set Open_Recordset = Nothing

    Set Open_Recordset = New ADODB.Recordset
    Open_Recordset.CursorLocation = adUseClient
    
    strSelect = "SELECT " & strSelect
    strFrom = " FROM " & strFrom
    
    If Trim(strWhere) <> "" Then strWhere = " WHERE " & strWhere
    If Trim(strOrderBy) <> "" Then strOrderBy = " ORDER BY " & strOrderBy
    
    Open_Recordset.Open strSelect & strFrom & strWhere & strOrderBy, conApp, adOpenDynamic, adLockOptimistic
    
    If Not blnActive Then Set Open_Recordset.ActiveConnection = Nothing
    
    If Open_Recordset.RecordCount > 0 Then Open_Recordset.MoveFirst
End Function

Public Function Table_Exist(ByRef conApp As ADODB.Connection, ByVal strTable As String) _
    As Boolean
Dim rstTable As ADODB.Recordset

    Set rstTable = conApp.OpenSchema(adSchemaTables, Array(Empty, Empty, Empty, "TABLE"))
    
    While Not rstTable.EOF
        If rstTable!TABLE_NAME = strTable Then
            Table_Exist = True
            
            Set rstTable = Nothing
            
            Exit Function
        End If
        
        rstTable.MoveNext
    Wend
    
    Table_Exist = False
    
    Set rstTable = Nothing
End Function

Public Function Search_Table(ByRef conApp As ADODB.Connection, ByVal strTable As String, _
    ByRef strTableNameBack() As String, Optional ByVal iLenName As Integer = 0, _
    Optional ByVal blnGetLeft As Boolean = True) As Boolean
Dim rstTable As ADODB.Recordset

Dim iCounter As Integer

    Set rstTable = conApp.OpenSchema(adSchemaTables, Array(Empty, Empty, Empty, "TABLE"))
    
    If iLenName = 0 Then iLenName = Len(strTable)
    
    iCounter = 0
    ReDim strTableNameBack(iCounter)
    iCounter = iCounter - 1
    
    Search_Table = False
    
    While Not rstTable.EOF
        If Len(rstTable!TABLE_NAME) >= iLenName Then
            If blnGetLeft Then
                If Left$(rstTable!TABLE_NAME, iLenName) = strTable Then
                    iCounter = iCounter + 1
                    
                    ReDim Preserve strTableNameBack(iCounter)
                
                    strTableNameBack(iCounter) = rstTable!TABLE_NAME
                    
                    Search_Table = True
                End If
            Else
                If Right$(rstTable!TABLE_NAME, iLenName) = strTable Then
                    iCounter = iCounter + 1
                
                    ReDim Preserve strTableNameBack(iCounter)
                
                    strTableNameBack(iCounter) = rstTable!TABLE_NAME
                    
                    Search_Table = True
                End If
            End If
        End If
        
        rstTable.MoveNext
    Wend
    
    Set rstTable = Nothing
End Function

Public Function Open_Connection(ByVal strDatabase As String, Optional ByVal strServer As String = "localhost", _
    Optional ByVal strUser As String = "sa", Optional ByVal blnSQLServer As Boolean = True) As ADODB.Connection
Dim strConnect As String

    Set Open_Connection = New ADODB.Connection
    
    If blnSQLServer Then
        strConnect = "Provider=SQLOLEDB.1"
        
        Open_Connection.Open strConnect & ";Persist Security Info=False;" & _
            "User ID=" & strUser & ";Initial Catalog=" & strDatabase & ";Data Source=" & strServer
    Else
        strConnect = "Microsoft.Jet.OLEDB.4.0"
        
        Open_Connection.Provider = strConnect
        Open_Connection.Open strDatabase
    End If
End Function

Public Sub Searching_Recordset(ByRef rstSearch As ADODB.Recordset, strKeySearch As String, _
    ByVal strSearchCriteria As String)
    With rstSearch
        If .RecordCount > 0 Then .MoveFirst
        
        .Find strKeySearch & "='" & strSearchCriteria & "'"
    End With
End Sub

Public Sub Initializer_Database_Performance(ByRef conApp As ADODB.Connection, _
    ByRef pgbCounter As ProgressBar)
Dim rstTable As ADODB.Recordset
Dim rstFields As ADODB.Recordset

Dim iCounter As Integer

    Set rstTable = conApp.OpenSchema(adSchemaTables, Array(Empty, Empty, Empty, "TABLE"))
    
    iCounter = 0
    
    While Not rstTable.EOF
        iCounter = iCounter + 1
        
        rstTable.MoveNext
    Wend
    
    rstTable.MoveFirst
    
    pgbCounter.Max = iCounter
    pgbCounter.Value = 0
    
    While Not rstTable.EOF
        pgbCounter.Value = pgbCounter.Value + 1
    
        Set rstFields = Nothing
        Set rstFields = Open_Recordset(conApp, "*", rstTable!TABLE_NAME, False)
        
        If rstFields.RecordCount <= 0 Then conApp.Execute "DROP TABLE " & _
            rstTable!TABLE_NAME
        
        rstTable.MoveNext
    Wend
    
    Set rstFields = Nothing
    Set rstTable = Nothing
End Sub

Public Sub Backup_Database(ByRef conApp As ADODB.Connection, ByVal strPathFile As String, ByVal strDatabase As String, ByVal strFileName As String, Optional ByVal blnMessageBox As Boolean = True)
Dim strBackup_Query As String
Dim strFile_Backup As String

    strFile_Backup = strFileName
    
    strBackup_Query = "BACKUP DATABASE " & strDatabase
    strBackup_Query = strBackup_Query & " TO DISK='" & strPathFile & strFile_Backup & "'"
    
    If Not fso.FolderExists(strPathFile) Then fso.CreateFolder strPathFile
    If fso.FileExists(strPathFile & strFile_Backup) Then fso.DeleteFile strPathFile & strFile_Backup, True

    conApp.Execute strBackup_Query
    
    If blnMessageBox Then MsgBox MSG_BACKUP_SUCCESS, MSG_BOX_CONTROL_OK_INFO, BACKUP
End Sub
